=== debian/changelog ===
retroarch (1.22.2+dfsg-1) unstable; urgency=medium

  * New upstream release
    * Drop 08_CVE-2025-9136.patch
    * Add Build-Depends for libxxhash-dev + libzstd-dev
    * Update debian/copyright
  * Fix Build-Depends / Build-Depends-Arch up
  * Update copyright file to drop old FSF postal address
  * Update debian/watch to v4

 -- Jonathan McDowell <noodles@earth.li>  Thu, 11 Dec 2025 19:33:57 +0000
