=== debian/control ===
Source: retroarch
Section: otherosfs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Jonathan McDowell <noodles@earth.li>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Arch: glslang-dev,
               libasound2-dev,
               libavcodec-dev,
               libavdevice-dev,
               libavformat-dev,
               libavutil-dev,
               libdbus-1-dev,
               libdrm-dev,
               libegl-dev,
               libflac-dev,
               libfreetype-dev,
               libgbm-dev (>= 9.0),
               libglm-dev,
               libjack-jackd2-dev,
               libminiupnpc-dev,
               libopenal-dev,
               libpipewire-0.3-dev,
               libpulse-dev,
               libsdl2-dev,
               libspirv-cross-c-shared-dev,
               libstb-dev,
               libswscale-dev,
               libudev-dev,
               libusb-1.0-0-dev (>= 1.0.16),
               libv4l-dev,
               libvulkan-dev,
               libx11-xcb-dev,
               libxinerama-dev,
               libxml2-dev,
               libxv-dev,
               libxxf86vm-dev,
               libxxhash-dev,
               libzstd-dev,
               pkgconf,
               python3-dev,
               qtbase5-dev,
               spirv-tools,
               wayland-protocols,
               x11proto-xext-dev,
               zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://www.libretro.com/
Vcs-Browser: https://salsa.debian.org/games-team/libretro/retroarch
Vcs-Git: https://salsa.debian.org/games-team/libretro/retroarch.git
Rules-Requires-Root: no

Package: retroarch
Architecture: any
Depends: fonts-dejavu-core,
         libretro-core-info,
         retroarch-assets (>= 1.7.6+git20221024+dfsg),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: libgamemode0
Suggests: xdg-utils
Description: Simple frontend for the libretro library
 RetroArch is an open source, multi-platform frontend for the libretro API.
 It can be used as a modular multi emulator system, game engine, media player
 and 3D technical demonstration. These features are available through
 libretro cores.
 .
 It provides four built-in interfaces: Ozone, GLUI, RGUI and XMB.

Package: retroarch-dev
Architecture: all
Section: devel
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Development files for the libretro library
 RetroArch is an open source, multi-platform frontend for the libretro API.
 It can be used as a modular multi emulator system, game engine, media player
 and 3D technical demonstration. These features are available through
 libretro cores.
 .
 This package contains include files of use to projects that are integrating
 with the libretro ecosystem.
